 /*
 * Texas Northern Model Railroad Club
 * Yard C west end contorl Sketch.
 * Controls access to Yard C from Yard A track 11, and Mountain mainline.
 * 
 
 */
 
#include <Wire.h>
#include <arduino.h>
#include "Adafruit_MCP23017.h"

// adjust this label if relay default should be HIGH.
#define TURNOUTACTIVE HICH
#define TURNOUTDEFAULT LOW

int current_state; // state is 1 to 8, 8 track yard.
int last_state; // state from last Slave read.

//saved value for relay control.
int turnout_pins[9] = {13,4,5,6,7,8,9,10,11}; // index 1 to 9, 0 not used.
int turnout_value[9] = {LOW,LOW,LOW,LOW,LOW,LOW,LOW,LOW,LOW};


const int numOfBoards = 2;
Adafruit_MCP23017 mcp0; // remote panel classes.
Adafruit_MCP23017 mcp1; // remote panel classes.
//Adafruit_MCP23017 mcp2; // remote panel classes.
//Adafruit_MCP23017 mcp3; // remote panel classes.

void setup() {
  
    Serial.begin(9600);
    while (!Serial) {
      ; // wait for serial port to connect. Needed for native USB port only
    }
    Serial.println("I2C Master - Thomas Stephens");
    Serial.println("TXNMRRC Yard 43/46 entrance Master with I2C connections to I/O boards.");
    Serial.println("Each board is a 16 position control panel with button to select route and LED to show selected route. Managed by read/write from I2C master");
    Serial.println("Source code is in TXNMRRC GitHub repository. V1.0.1");

    
// set I2C board(s) to default settings
  mcp0.begin(0); // zero is default single board
  Serial.println("begin mcp0");
    for (int x = 0;x < 8;x++) {
      mcp0.pinMode(x, INPUT);
      mcp0.pullUp(x, HIGH);  // turn on a 100K pullup internally
      mcp0.pinMode(x + 8, OUTPUT);
      mcp0.digitalWrite(x + 8, LOW);
  }
  if (numOfBoards > 1) { // must be at least 2
    mcp1.begin(1); // second board if available - repeat for boards 3 and 4
    Serial.println("begin mcp1");
      for (int x = 0;x < 8;x++) {
        mcp1.pinMode(x, INPUT);
        mcp1.pullUp(x, HIGH);  // turn on a 100K pullup internally
        mcp1.pinMode(x + 8, OUTPUT);
        mcp1.digitalWrite(x + 8, LOW);
    }
  }
/*
        mcp[y].begin(panel_id[y]);
    for (int x = 0;x < 8;x++) {
      mcp[y].pinMode(x, INPUT);
      mcp[y].pullUp(x, HIGH);  // turn on a 100K pullup internally
      mcp[y].pinMode(x + 8, OUTPUT);
      mcp[y].digitalWrite(x + 8, LOW);
  }
        mcp[y].begin(panel_id[y]);
    for (int x = 0;x < 8;x++) {
      mcp[y].pinMode(x, INPUT);
      mcp[y].pullUp(x, HIGH);  // turn on a 100K pullup internally
      mcp[y].pinMode(x + 8, OUTPUT);
      mcp[y].digitalWrite(x + 8, LOW);
  }
*/

  // set switch relays to mode and default setting
    Serial.println("set relay defailt values");
	for (int x=0; x < 9; x++) {
		pinMode(turnout_pins[x], OUTPUT);
		turnout_value[x] = TURNOUTDEFAULT;
		digitalWrite(turnout_pins[x], turnout_value[x]); 
	}  ;

  // set default state as mainline.
  current_state = 0;
  last_state = 1;
    Serial.println("set state");

  set_state ();
 
}


// ******* function to set slave display and set turnout motor relays to new values.
void set_state()
{
 Serial.print("set state ");
Serial.println(current_state);
digitalWrite(turnout_pins[0], HIGH);
  
mcp0.writeGPIOAB(0x00ff); // clear and reset all
	// mcp0.digitalWrite( current_state + 8, HIGH);
  if (numOfBoards > 1 > 0) {
        mcp1.writeGPIOAB(0x00ff); // clear and reset all
     //   mcp1.digitalWrite( current_state + 8, HIGH);
    }

    // set relay status
    switch (current_state) {
      case 0:
        // align switches for mainline running.
        Serial.println("set state - 1");
        turnout_value[1] = LOW;
        turnout_value[2] = LOW;
        turnout_value[3] = LOW;
        turnout_value[4] = LOW;
        turnout_value[5] = LOW;
        turnout_value[6] = LOW;
        turnout_value[6] = LOW;
        break; // break to avoid running two states together
      case 1:
        // align switches for mainline running.
        Serial.println("set state -- 2");
        turnout_value[1] = LOW;
        turnout_value[2] = LOW;
        turnout_value[3] = HIGH;
        turnout_value[4] = LOW;
        turnout_value[5] = LOW;
        turnout_value[6] = LOW;
        turnout_value[6] = LOW;
        break; // break to avoid running two states together
      
      case 2:
        // align switches for mainline running.
        Serial.println("set state --- 3");
        turnout_value[1] = LOW;
        turnout_value[2] = HIGH;
        turnout_value[3] = LOW;
        turnout_value[4] = LOW;
        turnout_value[5] = LOW;
        turnout_value[6] = LOW;
        turnout_value[6] = LOW;
        break; // break to avoid running two states together
      
      case 3:
        // align switches for mainline running.
        Serial.println("set state ---- 4");
        turnout_value[1] = LOW;
        turnout_value[2] = HIGH;
        turnout_value[3] = LOW;
        turnout_value[4] = HIGH;
        turnout_value[5] = LOW;
        turnout_value[6] = LOW;
        turnout_value[7] = LOW;
        break; // break to avoid running two states together
      
      case 4:
        // align switches for mainline running.
        Serial.println("set state ----- 5");
        turnout_value[1] = HIGH;
        turnout_value[2] = LOW;
        turnout_value[3] = LOW;
        turnout_value[4] = LOW;
        turnout_value[5] = LOW;
        turnout_value[6] = LOW;
        turnout_value[7] = LOW;
        break; // break to avoid running two states together
      
      case 5:
        // align switches for mainline running.
        Serial.println("set state ------ 6");
        turnout_value[1] = HIGH;
        turnout_value[2] = LOW;
        turnout_value[3] = LOW;
        turnout_value[4] = LOW;
        turnout_value[5] = LOW;
        turnout_value[6] = HIGH;
        turnout_value[7] = LOW;
        break; // break to avoid running two states together
      
      case 6:
        // align switches for mainline running.
        Serial.println("set state ------- 7");
        turnout_value[1] = HIGH;
        turnout_value[2] = LOW;
        turnout_value[3] = LOW;
        turnout_value[4] = LOW;
        turnout_value[5] = HIGH;
        turnout_value[6] = LOW;
        turnout_value[7] = LOW;
        break; // break to avoid running two states together
      
      case 7:
        // align switches for mainline running.
        Serial.println("set state -------- 8");
        turnout_value[1] = HIGH;
        turnout_value[2] = LOW;
        turnout_value[3] = LOW;
        turnout_value[4] = LOW;
        turnout_value[5] = HIGH;
        turnout_value[6] = LOW;
        turnout_value[7] = HIGH;
        break; // break to avoid running two states together
            
      case 8:
        // align switches for mainline running.
        Serial.println("set state -------- 8");
        turnout_value[1] = HIGH;
        turnout_value[2] = HIGH;
        turnout_value[3] = HIGH;
        turnout_value[4] = HIGH;
        turnout_value[5] = HIGH;
        turnout_value[6] = HIGH;
        turnout_value[7] = HIGH;
        break; // break to avoid running two states together
      

    } // set switch status
 
 // set control pin values, this throws or clears each switch relay.
	for (int x=1; x < 9; x++){
		digitalWrite(turnout_pins[x], turnout_value[x]); 
	};
	last_state = current_state; // reset states to equal.
  Serial.println("pause");
	delay (5000); // 5 seconds - to allow turnout motors to cycle completely between settings.
  //mcp0.writeGPIOAB(0x00ff); // clear and reset all
  mcp0.digitalWrite( current_state + 8, HIGH);
  if (numOfBoards > 1 > 0) {
    //    mcp1.writeGPIOAB(0x00ff); // clear and reset all
        mcp1.digitalWrite( current_state + 8, HIGH);
    }
	digitalWrite(turnout_pins[0], LOW);
 Serial.println("run");
}
// **************************** main loop ******************
void loop() {

// poll slaves for their current state.
/*
with MCP23017 ships or boards,each has an address, 20-27. .
The x loop scans for a button push. Ddefault is HIGH, so LOW is pushed button. 
Note that if more than one button is pushed, the button with highest number on last slave panel is used.

*/

  Serial.println("testing panel_id 0");
		for (int x = 0;x < 8;x++) 
			{
      int value;
      Serial.print(" # ");
      Serial.print(x);
      Serial.print(" = ");
      value = mcp0.digitalRead( x );
      Serial.println(value);
			if (value == LOW) 
				{	
				current_state = x;
				Serial.print("button pushed panel_id 0::");
				Serial.println(x);
				}
			}
    if (numOfBoards > 1) {
    Serial.println("testing panel_id 1");
    for (int x = 0;x < 8;x++) 
      {
      int value;
      Serial.print(" # ");
      Serial.print(x);
      Serial.print(" = ");
      value = mcp1.digitalRead(x);
      Serial.println(value);
      if (value == LOW) 
        { 
        current_state = x;
        Serial.print("button pushed panel_id 1::");
        Serial.println(x);
        }
      }     
    }
		
	if (last_state != current_state) 
	{
  Serial.println("----------------state change-----------");
		set_state();

	}
// test routine to test remote panel connections
delay (1000); // 100 milliseconds - to allow I2C chip to debounce and stabilize button reading.
} 
