/*
 * Texas Northern Model Railroad Club
 * Yard C west end contorl Sketch.
 * Controls access to Yard C from Yard A track 11, and Mountain mainline.
 * 
 
 */

#include <Wire.h>
#include <arduino.h>

// int current_state; // state is 1 to 8, 8 track yard.
int last_state; // last update state.
int active_slaves = 1;

//saved value for relay control.
int turnout_pins[9] = {13,3,4,5,6,7,8,9,10}; // index 1 to 9, 0 not used.
int turnout_value[9] = {LOW,LOW,LOW,LOW,LOW,LOW,LOW,LOW,LOW};

byte panel_id[4] = {8, 0, 0, 0}; // allow for future multiple panels, First valid address is 8



void setup() {

  Serial.begin(9600);
  Serial.println("testing TXNMRRC Yard 44/46 entrance Master with I2C connections to slaves.");

Wire.begin ();
// set switch relays to output
  int x;
for (x=0; x < 9; x++){
	pinMode(turnout_pins[x], OUTPUT);
	turnout_value[x] = LOW;
	digitalWrite(turnout_pins[x], turnout_value[x]); 
}  ;

// set default state as mainline.
// current_state = 1;
last_state = 1;

set_state (last_state);
 
}

void loop() {

// poll slaves for their current state.

// test routine to test turnout motor connections
	
delay (10000); // 10 seconds
for (int x = 0; x < 8; x++) {
	Serial.print("setting state: ");
	set_state(x);
	  Serial.println(x);
  }

  } 


int set_state(byte new_state)
{
 
    // set light status
    switch (new_state) {
      case 0:
        // align switches for mainline running.
        Serial.println("set state - 0");
        turnout_value[1] = LOW;
        turnout_value[2] = LOW;
//        turnout_value[3] = LOW;
        turnout_value[4] = LOW;
 //       turnout_value[5] = LOW;
 //       turnout_value[6] = LOW;
 //       turnout_value[6] = LOW;
        break; // break to avoid running two states together
      case 1:
        // align switches for mainline running.
        Serial.println("set state - 1");
        turnout_value[1] = LOW;
        turnout_value[2] = LOW;
//        turnout_value[3] = LOW;
        turnout_value[4] = HIGH;
//        turnout_value[5] = LOW;
//        turnout_value[6] = LOW;
 //       turnout_value[6] = LOW;
        break; // break to avoid running two states together
      
      case 2:
        // align switches for mainline running.
        Serial.println("set state - 2");
        turnout_value[1] = LOW;
        turnout_value[2] = HIGH;
//        turnout_value[3] = LOW;
//        turnout_value[4] = LOW;
        turnout_value[5] = LOW;
//        turnout_value[6] = LOW;
 //       turnout_value[6] = LOW;
        break; // break to avoid running two states together
      
      case 3:
        // align switches for mainline running.
        Serial.println("set state - 3");
        turnout_value[1] = LOW;
        turnout_value[2] = HIGH;
 //       turnout_value[3] = LOW;
//      turnout_value[4] = LOW;
        turnout_value[5] = HIGH;
//        turnout_value[6] = LOW;
//        turnout_value[7] = LOW;
        break; // break to avoid running two states together
      
      case 4:
        // align switches for mainline running.
        Serial.println("set state - 4");
        turnout_value[1] = HIGH;
//        turnout_value[2] = LOW;
        turnout_value[3] = LOW;
//        turnout_value[4] = LOW;
//        turnout_value[5] = LOW;
        turnout_value[6] = LOW;
//        turnout_value[7] = LOW;
        break; // break to avoid running two states together
      
      case 5:
        // align switches for mainline running.
        Serial.println("set state - 5");
        turnout_value[1] = HIGH;
//        turnout_value[2] = LOW;
        turnout_value[3] = LOW;
//        turnout_value[4] = LOW;
//        turnout_value[5] = LOW;
        turnout_value[6] = HIGH;
//        turnout_value[7] = LOW;
        break; // break to avoid running two states together
      
      case 6:
        // align switches for mainline running.
        Serial.println("set state - 6");
        turnout_value[1] = HIGH;
//        turnout_value[2] = LOW;
        turnout_value[3] = HIGH;
//        turnout_value[4] = LOW;
//        turnout_value[5] = LOW;
//        turnout_value[6] = LOW;
        turnout_value[7] = LOW;
        break; // break to avoid running two states together
      
      case 7:
        // align switches for mainline running.
        Serial.println("set state - 7");
        turnout_value[1] = HIGH;
//        turnout_value[2] = LOW;
        turnout_value[3] = HIGH;
//        turnout_value[4] = LOW;
//        turnout_value[5] = LOW;
//        turnout_value[6] = LOW;
        turnout_value[7] = HIGH;
        break; // break to avoid running two states together
      

    } // set switch status
 
int x;
	for (x=1; x < 9; x++){
		digitalWrite(turnout_pins[x], turnout_value[x]); 
	};
  last_state = new_state; // reset states to equal.
  for (int y = 0;y < active_slaves; y++)
  {
    Serial.print("sending to slave #");
    Serial.println(panel_id[y]);
    Wire.beginTransmission(panel_id[y]); // transmit to device #1
    Wire.write(new_state);              // sends one byte  
    Wire.endTransmission();    // stop transmitting
  }
  Serial.println("pause");

  delay (5000); // 5 seconds - to allow turnout motors to cycle completely between settings.
    //mcp0.writeGPIOAB(0x00ff); // clear and reset all
 
  Serial.println("run after state update");
}
